Home | History | Annotate | Download | only in adeb
      1 #!/bin/bash -e
      2 #
      3 # (c) Joel Fernandes <joel (at] joelfernandes.org>
      4 
      5 VERSION=v0.99g
      6 
      7 spath="$(dirname "$(readlink -f "$0")")"
      8 # spath=$( cd "$(dirname "$0")" ; pwd -P )
      9 curdir=$( pwd -P )
     10 source $spath/utils/support
     11 source $spath/utils/banners
     12 
     13 # Set default vars
     14 DISTRO=buster; ARCH=arm64
     15 ADB="adb"
     16 FULL=0				# Default to a minimal install
     17 DOWNLOAD=1			# Default to downloading from web
     18 SKIP_DEVICE=0			# Skip device preparation
     19 INSTALL_BCC=0			# Decide if BCC is to be installed
     20 
     21 # Default packages
     22 PACKAGES=""
     23 DEFAULT_PACKAGES="bash ca-certificates apt net-tools iputils-ping procps vim"
     24 
     25 EXTRA_FILES="none"
     26 
     27 config_full_build() {
     28 	for f in $(ls $spath/packages); do source $spath/packages/$f; done;
     29 }
     30 
     31 # Parse command line parameters
     32 if [ $# -lt 1 ]; then usage; fi; POSITIONAL=()
     33 while [[ $# -gt 0 ]]; do key="$1";
     34 
     35 # If its shell mode, any future args become shell's args
     36 if [ "x$ASHELL" == "x1" ]; then
     37 	if [ -z "$SHELL_ARGS" ]; then
     38 		SHELL_ARGS=$key
     39 	else
     40 		SHELL_ARGS="$SHELL_ARGS $key"
     41 	fi
     42 	shift || true; continue
     43 fi
     44 
     45 case $key in
     46     shell) ASHELL=1;     shift || true;     ;;
     47     remove) REMOVE=1;     shift || true;     ;;
     48     git-pull) GIT_PULL=1; shift || true; ;;
     49     pull) PULL=1; shift || true; break	;;
     50     push) PUSH=1; shift || true; break	;;
     51     prepare) PREPARE=1;  shift || true;    ;;
     52     --full) FULL=1; config_full_build; shift || true; ;;
     53     --arch) ARCH=$2; shift || true; shift || true; ;;
     54     --archive) DOWNLOAD=0; TARF=$2; shift || true; shift || true; ;;
     55     --bcc) FULL=1; source $spath/packages/bcc; shift || true;     ;;
     56     --kernelsrc) KERNELSRC="$2"; shift || true;     shift || true;     ;;
     57     --skip-install) SKIP_INSTALL=1; shift || true; ;;
     58     --kernel-headers-targz) KERNELHDRS=$2; shift || true;	shift || true;	;;
     59     --tempdir) TDIR="$2"; shift || true;     shift || true;     ;;
     60     --build) DOWNLOAD=0;  shift || true;     ;;
     61     --buildtar) BTAR=1; DOWNLOAD=0; TARDIR="$2"; shift || true;     shift || true;     ;;
     62     --device|-s) ADB="$ADB -s $2"; shift || true; shift || true; ;;
     63     --build-image) BI=1; BUILD_IMAGEF=$2; SKIP_DEVICE=1; DOWNLOAD=0; shift || true; shift || true; ;;
     64     --debug) set -x; shift || true; ;;
     65     *) c_error "Unknown option ($1)"; usage; ;;
     66 esac
     67 done
     68 
     69 [ -z $ASHELL ] && box_out "adeb: $VERSION"
     70 
     71 if [ $FULL -eq 1 ]; then
     72 	FNAME=androdeb-fs.tgz.zip
     73 	FNAME_UZ=androdeb-fs.tgz
     74 else
     75 	FNAME=androdeb-fs-minimal.tgz.zip
     76 	FNAME_UZ=androdeb-fs-minimal.tgz
     77 fi
     78 
     79 if [ ! -z $BTAR ] && [ -z $TARDIR ]; then
     80 	TARDIR=$spath
     81 fi
     82 
     83 if [ ! -z "$GIT_PULL" ]; then
     84 	c_info "Updating androdeb by git pull"
     85 	cd $spath
     86 	git pull
     87 	c_info "Done."
     88 	exit 0
     89 fi
     90 
     91 if [ ! -z "$PULL" ]; then
     92 	if [ $1 == "-a" ]; then
     93 		PRESERVE="-a"
     94 		c_info "Preserving filestamps and mode"
     95 		shift || true
     96 	fi
     97 	file_count=`count_sources $@`
     98 	i=0
     99 	while [ $i -lt $file_count ]; do
    100 		files["$i"]=/data/androdeb/debian/$1
    101 		shift || true
    102 		i=$((i + 1))
    103 	done
    104 	$ADB pull $PRESERVE "${files[@]}" "$@"
    105 	exit 0
    106 fi
    107 
    108 if [ ! -z "$PUSH" ]; then
    109 	file_count=`count_sources $@`
    110 	i=0
    111 	while [ $i -lt $file_count ]; do
    112 		files["$i"]=$1
    113 		shift || true
    114 		i=$((i + 1))
    115 	done
    116 	dest=/data/androdeb/debian/$1
    117 	$ADB push $sync "${files[@]}" $dest
    118 	exit 0
    119 fi
    120 
    121 if [[ ! -z ${TARDIR+x} ]] && [[ ! -d $TARDIR ]]; then die 7 "Tar dir specified doesn't exist"; fi
    122 
    123 if [ -z $BI ]; then
    124 	[ -z $ASHELL ] && c_info "Looking for device.."
    125 	set +e
    126 	do_adb_root "$ADB"
    127 
    128 	if [ $? -ne 0 ]; then
    129 		c_error "adb root failed, make sure:"
    130 		c_error " * If multiple devices connected, provide --device <serialno>  (or -s <serialno>)"
    131 		c_error " * Try to run \"adb root\" manually and see if it works. Typically this needs a userdebug build."
    132 		c_error ""
    133 		c_error "Note: adb can be typically obtained using the android-tools-adb or the adb"
    134 		c_error "packages on your distro, or by installing the Android SDK."
    135 		die 3 "Exiting."
    136 	fi
    137 	set -e
    138 else
    139 	[ ! -z $BUILD_IMAGEF ] || die 8 "--build-image passed but no image file provided"
    140 fi
    141 
    142 if [ ! -z "$REMOVE" ]; then
    143 	die_if_no_androdeb "Nothing to remove."
    144 	$ADB shell /data/androdeb/device-umount-all || true;
    145 	$ADB shell rm -rf /data/androdeb; exit 0; fi
    146 
    147 ##########################################################
    148 #  SHELL
    149 ##########################################################
    150 if [ ! -z ${ASHELL+x} ]; then
    151 	set +e; $ADB shell ls /data/androdeb/debian/.bashrc > /dev/null 2>&1
    152 	if [ $? -ne 0 ]; then
    153 	   die 2 "Device doesn't have an androdeb environment, run \"./androdeb prepare\" first";
    154 	fi; set -e
    155 
    156 	if [ ! -z ${SHELL_ARGS+x} ]; then
    157 		# Explanation of quotes:
    158 		# Outer quote is so that androdeb's bash passes the SHELL_ARGS as a single
    159 		# argument to $ADB shell. Inner quotes is so that run-command can receive all
    160 		# the args even though they may be separated by spaces. \m/
    161 		$ADB shell -t /data/androdeb/run-command "\"$SHELL_ARGS\""
    162 	else
    163 		$ADB shell -t /data/androdeb/run
    164 	fi
    165 
    166 	exit 0
    167 fi
    168 
    169 ##########################################################
    170 #  PREPARE 
    171 ##########################################################
    172 
    173 function do_cleanup() {
    174 	rm -rf $TDIR/*; if [ $MKTEMP -eq 1 ]; then rm -rf $TDIR; fi
    175 }
    176 
    177 function push_unpack_headers() {
    178 	die_if_no_androdeb "Couldn't update headers."
    179 
    180 	c_info "Storing kernel headers into androdeb /kernel-headers/"
    181 	$ADB shell rm -rf /data/androdeb/debian/kernel-headers/
    182 	$ADB shell mkdir  /data/androdeb/debian/kernel-headers/
    183 	run_quiet $ADB push $TDIR_ABS/kh.tgz /data/androdeb/
    184 	$ADB shell tar -xvf /data/androdeb/kh.tgz -C /data/androdeb/debian/kernel-headers/ > /dev/null
    185 	$ADB shell rm /data/androdeb/kh.tgz
    186 }
    187 
    188 function push_unpack_tarred_headers() {
    189 	die_if_no_androdeb "Couldn't update headers."
    190 
    191 	$ADB shell rm -rf /data/androdeb/debian/kernel-headers/
    192 	$ADB shell mkdir  /data/androdeb/debian/kernel-headers/
    193 
    194 	c_info "Pushing headers tar onto device"
    195 	run_quiet $ADB push $1 /data/androdeb/
    196 
    197 	c_info "Storing kernel headers into androdeb root directory"
    198 	$ADB shell tar -xvf /data/androdeb/$(basename $1) -C /data/androdeb/debian/ > /dev/null
    199 
    200 	$ADB shell rm /data/androdeb/$(basename $1)
    201 }
    202 
    203 function all_done_banner() {
    204 	c_info "All done! Run \"adeb shell\" to enter environment"
    205 }
    206 
    207 function detect_repo_url() {
    208 	ADEB_REPO_URL=`cd $spath && git config -l | grep -m1 remote | grep url | sed -e "s/.*url=//" \
    209 		 -e "s/.*@//"  \
    210 		 -e "s/https:\/\///" \
    211 		 -e "s/:/\//"  \
    212 		 -e "s/\.git$//"`"/"
    213 	c_info "Detected URL: $ADEB_REPO_URL"
    214 }
    215 
    216 function check_repo_url () {
    217 	if [ -z $ADEB_REPO_URL ]; then
    218 		c_info "No repository URL provided in enviromnent. Attempting to auto-detect it"
    219 		detect_repo_url
    220 	fi
    221 
    222 	if [ -z $ADEB_REPO_URL ]; then
    223 		c_warning "Automatic download is disabled. To enable it, please set the \$ADEB_REPO_URL"
    224 		c_warning "environment variable as recommended in the setup instructions in the README.md"
    225 		do_cleanup
    226 		exit 0
    227 	fi
    228 }
    229 
    230 function download_headers() {
    231 	KERNEL_MAJOR=`$ADB shell uname -r | cut -d - -f 1 | cut -d . -f 1`
    232 	KERNEL_MINOR=`$ADB shell uname -r | cut -d - -f 1 | cut -d . -f 2`
    233 	KERNEL_VERSION="$KERNEL_MAJOR.$KERNEL_MINOR"
    234 	PREBUILT_HEADERS_FILE=headers-$ARCH-$KERNEL_VERSION.tar.gz.zip
    235 
    236 	check_repo_url
    237 
    238 	curl -L https://$ADEB_REPO_URL/releases/download/$VERSION/$PREBUILT_HEADERS_FILE --output $TDIR_ABS/$PREBUILT_HEADERS_FILE ||
    239 		   die 9 "Failed to download kernel headers. Please check your internet connection and repository URL"
    240 
    241 	unzip -e $TDIR_ABS/$PREBUILT_HEADERS_FILE -d $TDIR_ABS/ ||
    242 		   die 10 "Failed to download kernel headers. Kernel $KERNEL_VERSION for $ARCH may not be supported or ADEB_REPO_URL is incorrect."
    243 	KERNELHDRS=$TDIR_ABS/`echo "$PREBUILT_HEADERS_FILE" | sed "s/.zip//"`
    244 }
    245 
    246 # Prepare is the last command checked
    247 if [ -z "$PREPARE" ]; then usage; fi
    248 
    249 if [ ! -z "$TARF" ] && [ ! -f $TARF ] && [ -z "$DOWNLOAD" ]; then die 5 "archive provided doesn't exist"; fi
    250 
    251 if [ ! -z "$KERNELSRC" ] && [ ! -d $KERNELSRC ]; then die 6 "Kernel source directory provided doesn't exist"; fi
    252 
    253 if [ ! -z "$KERNELHDRS" ] && [ ! -f $KERNELHDRS ]; then die 7 "Kernel headers tar.gz doesn't exist"; fi
    254 
    255 print_prepare_banner
    256 
    257 # Where do we want to store temporary files
    258 MKTEMP=0; if [[ -z ${TDIR+x} ]]  || [[ ! -d "${TDIR}" ]]; then
    259 	TDIR=`mktemp -d`; MKTEMP=1; fi
    260 rm -rf $TDIR/*
    261 TDIR_ABS=$( cd "$TDIR" ; pwd -P )
    262 
    263 if [ $DOWNLOAD -eq 1 ]; then
    264    c_info "Downloading Androdeb from the web..."; c_info ""
    265 
    266    # Github dropped tar gz support! ##?#??#! Now we've to zip everything.
    267    check_repo_url
    268 
    269    curl -L https://$ADEB_REPO_URL/releases/download/$VERSION/$FNAME --output $TDIR_ABS/$FNAME ||
    270 		   die 9 "Failed to download adeb release."
    271 
    272    unzip -e $TDIR_ABS/$FNAME -d $TDIR_ABS/ ||
    273 		   die 10 "Failed to download adeb release. Double check the ADEB_REPO_URL value."
    274    TARF=$TDIR_ABS/$FNAME_UZ
    275 fi
    276 
    277 if [ ! -z "$FULL" ] && [ -z "$KERNELSRC" ] && [ -z "$KERNELHDRS" ] && [ -z "$BI" ]; then
    278 	c_info "Kernel headers are needed but none were provided. Downloading pre-built headers"
    279 	download_headers
    280 fi
    281 
    282 OUT_TMP=$TDIR/debian; rm -rf $OUT_TMP; mkdir -p $OUT_TMP
    283 
    284 # Unpack the supplied kernel headers tar.gz directly into androdeb root
    285 if [ ! -z "$KERNELHDRS" ]; then
    286 	c_info "Building updating kernel headers from supplied tar.gz ($KERNELHDRS)"
    287 
    288 	# Is header tar gz update the only thing left to do?
    289 	if [[ ! -z "$SKIP_INSTALL" ]]; then
    290 		c_info "Skipping install"
    291 		push_unpack_tarred_headers $KERNELHDRS; do_cleanup; all_done_banner; exit 0; fi
    292 
    293 	tar -xvf $KERNELHDRS -C $OUT_TMP/ > /dev/null
    294 fi
    295 
    296 # Package kernel headers
    297 if [ ! -z "$KERNELSRC" ]; then
    298 	c_info "Building and updating kernel headers from kernel source dir ($KERNELSRC)"
    299 	$spath/bcc/build-kheaders-targz.sh ${KERNELSRC} $TDIR_ABS/kh.tgz > /dev/null
    300 
    301 	# Is header update the only thing left to do?
    302 	if [[ ! -z "$SKIP_INSTALL" ]]; then
    303 		c_info "Skipping install"
    304 		push_unpack_headers; do_cleanup; all_done_banner; exit 0; fi
    305 
    306 	mkdir $OUT_TMP/kernel-headers
    307 	tar -xvf $TDIR_ABS/kh.tgz -C $OUT_TMP/kernel-headers/ > /dev/null
    308 fi
    309 
    310 # Build FS from existing tar, very simple.
    311 if [ ! -z "$TARF" ]; then
    312 	c_info "Using archive at $TARF for filesystem preparation"
    313 	$ADB shell mkdir -p /data/androdeb/
    314 
    315 	c_info "Pushing filesystem to device.."
    316 	run_quiet $ADB push $TARF /data/androdeb/deb.tar.gz
    317 
    318 	c_info "Pushing addons to device.."
    319 	run_quiet $ADB push $spath/addons/* /data/androdeb/
    320 
    321 	c_info "Unpacking filesystem in device.."
    322 	run_quiet $ADB shell /data/androdeb/device-unpack
    323 
    324 	if [ ! -z "$KERNELHDRS" ]; then push_unpack_tarred_headers $KERNELHDRS; fi
    325 	if [ ! -z "$KERNELSRC" ]; then push_unpack_headers; fi
    326 
    327 	do_cleanup; all_done_banner; exit 0
    328 fi
    329 
    330 PACKAGES+="$DEFAULT_PACKAGES"
    331 c_info "Using temporary directory: $TDIR"
    332 
    333 if [[ $EUID -ne 0 ]]; then c_info "The next stage runs as sudo, please enter password if asked."; fi
    334 
    335 ex_files=$(mktemp); echo $EXTRA_FILES > $ex_files
    336 
    337 sudo $spath/buildstrap $ARCH $DISTRO $TDIR $OUT_TMP \
    338 		"$(make_csv "$PACKAGES")"\
    339 		$ex_files $INSTALL_BCC $SKIP_DEVICE
    340 rm $ex_files
    341 
    342 # If we only wanted to prepare a rootfs and don't have
    343 # a device connected, then just echo that and skip cleanup
    344 if [ $SKIP_DEVICE -eq 1 ]; then
    345 	c_info "Device preparation is being skipped for the selected options"
    346 	c_info "any builds that need to happen on device may be cloned but not built."
    347 
    348 	if [ ! -z $BI ]; then
    349 		sudo $spath/buildimage $OUT_TMP $(dirname $BUILD_IMAGEF)/$(basename $BUILD_IMAGEF)
    350 		sudo chmod a+rw $(dirname $BUILD_IMAGEF)/$(basename $BUILD_IMAGEF)
    351 		c_info "Your .img has been built! Enjoy!"
    352 	fi
    353 
    354 	do_cleanup
    355 	exit 0
    356 fi
    357 
    358 # Push tar to device and start unpack
    359 $ADB shell mkdir -p /data/androdeb/
    360 $ADB push $TDIR/deb.tar.gz /data/androdeb/
    361 $ADB push $spath/addons/* /data/androdeb/
    362 $ADB shell /data/androdeb/device-unpack
    363 
    364 # Build BCC and install bcc on device if needed
    365 if [ $INSTALL_BCC -eq 1 ]; then
    366 	$ADB shell /data/androdeb/run-command /bcc-master/build-bcc.sh;
    367 fi
    368 
    369 # Extract a tar of the built, compiled and installed androdeb env
    370 if [[ ! -z ${TARDIR+x} ]]; then
    371 	c_info "Creating tarball"
    372 	pushd $TARDIR
    373 	if [ $INSTALL_BCC -eq 0 ]; then
    374 		mv $TDIR/deb.tar.gz $FNAME_UZ
    375 	else
    376 		$ADB shell /data/androdeb/build-debian-tar
    377 		$ADB pull /data/androdeb/androdeb-fs.tgz $FNAME_UZ
    378 		$ADB shell rm /data/androdeb/androdeb-fs.tgz;
    379 	fi
    380 	zip -r $FNAME $FNAME_UZ
    381 	popd
    382 fi
    383 
    384 do_cleanup
    385 
    386 all_done_banner
    387